Option Compare Database
Option Explicit


'***This Subroutine adds node to their parent calling itself (recursive technique) *** 

Sub AddChildren(nodBoss As Node, rst As DAO.Recordset) 


 Dim nd As Node, StrText As String, bkMark As String, FoldType As Integer 


  rst.FindFirst "[GroupName] ='" & nodBoss & "'" 


 Do Until rst.NoMatch 

  StrText = rst![NodeName] 

  FoldType = rst!FoldType 

  Set nd = TreeView1.Nodes.Add(nodBoss, tvwChild, StrText, StrText, FoldType) 

  nd.Tag = StrText 

  bkMark = rst.Bookmark 

  AddChildren nd, rst 

  rst.Bookmark = bkMark 

  rst.FindNext "[GroupName] ='" & nodBoss & "'" 

 Loop 

End Sub 

'******* Form Load Event adds Parent Nodes reading value from Tree Table******** 

Private Sub Form_Load() 

 Dim db As Database, rst As Recordset, nd As Node 

 Dim StrText As String, bkMark As String, FoldType As Integer

  Set db = CurrentDb 

  Set rst = db.OpenRecordset("Tree Table", dbOpenDynaset, dbReadOnly) 

   rst.FindFirst "GroupName Is Null" 

   Do Until rst.NoMatch 

   StrText = rst![NodeName]

   FoldType = rst!FoldType 

   Set nd = TreeView1.Nodes.Add(, , StrText, StrText, FoldType) 

   nd.Tag = StrText 

   bkMark = rst.Bookmark 

   AddChildren nd, rst 

   rst.Bookmark = bkMark 

   rst.FindNext "GroupName Is Null" 

  Loop 

   TreeView1.Nodes(1).Expanded = True 

   TreeView1.Nodes(1).Image = 2 

   rst.Close 

   Set db = Nothing 

   AddList TreeView1.Nodes(1) 

End Sub 

'*********ListView Item Click event opens associated Forms/Reports ********** 

Private Sub ListView1_ItemClick(ByVal Item As Object) 

 Dim nd As Node, StrText As String, bkMark As String, FoldType As Integer 

 Dim dbs As Database, rst As Recordset, LItem As ListItem, TempText As String 

  Set dbs = CurrentDb 

  Set rst = dbs.OpenRecordset("TreeQuery", dbOpenDynaset, dbReadOnly) 

  TempText = "[NodeSub] ='" & Item & "'" 

  rst.FindFirst TempText 

  If rst.NoMatch = False Then 

  If rst!SubFold = 3 Then 

   Me.Visible = False 

   DoCmd.Restore 

   DoCmd.OpenForm rst!DocOpen, acNormal 

  ElseIf rst!SubFold = 5 Then 

   Me.Visible = False 

   DoCmd.Restore 

   DoCmd.OpenReport rst!DocOpen, acPreview 

  End If 

 End If 

   rst.Close 

   Set dbs = Nothing 


End Sub 

'**************Collapse event uses Closed Folder Image*****************

Private Sub TreeView1_Collapse(ByVal Node As Object) 

  Dim nd As Node 

 Set nd = Node 

 Node.Image = 1 

 ListView1.ListItems.Clear 

 AddList nd.Tag 

End Sub 

'************Expand event uses Open Folder Image***************** 

Private Sub TreeView1_Expand(ByVal Node As Object) 

  Dim nd As Node 

 Set nd = Node 

 Node.Image = 2 

 ListView1.ListItems.Clear 

 AddList nd.Tag 

End Sub 

'************Node click event calls Addlist Function to populate Listview******** 

Private Sub TreeView1_nodeclick(ByVal Node As Object) 

  Dim nd As Node, i As Integer, FoldType As Integer 

  Set nd = Node 

   If nd.Expanded = False Then 

   For i = 1 To TreeView1.Nodes.Count 

   TreeView1.Nodes(i).Expanded = False 

   FoldType = TreeView1.Nodes(i).Image 

   TreeView1.Nodes(i).Image = IIf(FoldType = 2, 1, FoldType) 

  Next i 

   End If 

   ListView1.ListItems.Clear 

   ListView1.Arrange = lvwAutoTop 

   Call AddList(nd.Tag) 

End Sub 

'***AddList Function Populates ListView & Opens Related Form/Report From TreeSub Table*** 

Sub AddList(nodBoss As String) 

  Dim nd As Node, StrText As String, bkMark As String, FoldType As Integer, DocType As String 

 Dim dbs As Database, rst As Recordset, LItem As ListItem, TempText As String, TempFold As Integer 

 Set dbs = CurrentDb 

 Set rst = dbs.OpenRecordset("TreeQuery", dbOpenDynaset, dbReadOnly) 

 TempText = "[NodeMain] ='" & nodBoss & "'" 

 rst.FindFirst TempText 

 TempFold = rst!MainFold 

  If TempFold = 6 Then 

   rst.Close 

   Set dbs = Nothing 

   DoCmd.Quit 

   Exit Sub 

  End If 

    DocType = rst!DocOpen 

   Do Until rst.NoMatch 

    StrText = rst![NodeSub] 

    FoldType = rst!SubFold 

    Set LItem = ListView1.ListItems.Add(, , StrText, FoldType) 

    bkMark = rst.Bookmark 

    AddList LItem.Tag 

    rst.Bookmark = bkMark 

    rst.FindNext TempText 

   Loop 

    ListView1.Arrange = lvwAutoTop 

   If TempFold = 3 Then 

    Me.Visible = False 

    DoCmd.Restore 

    DoCmd.OpenForm DocType, acNormal 

   ElseIf TempFold = 4 Then 

    Me.Visible = False 

    DoCmd.Restore 

    DoCmd.OpenReport DocType, acPreview 

   End If 

    rst.Close 

    Set dbs = Nothing 

End Sub 

